/* This file can be redistributed and used under GNU Library General Public
 * License. (c) 2000 Micha Moskal <malekith@topnet.pl>. 
 * $Id: inputline.cc,v 1.11 2001/02/03 17:00:36 malekith Exp $ */

#define _V_PRIVATE
#include <v/v.h>
#include <v/term.h>

void InputLine::draw()
{
	int col = is_active() ? 
			(deadly ? 
				color("inputline_deadly") : 
				color("inputline_selected")) : 
			color(ghosted ? "inputline_ghosted" : 
				"inputline_normal"), col2;
	int c2 = color("inputline_arrow");
	
	if (is_active() && deadly)
		col2 = color("inputline_selected");
	else
		col2 = col;
		
	if (cp < 0)
		cp = 0;
	if (cp > caption.strlen())
		cp = caption.strlen();
	if (fixed && cp == pos.w) {
		top = 0;
		cp--;
	}
	if (top + pos.w - 1 < cp)
		top = cp - pos.w + 1;
	if (top > cp)
		top = cp;
	char *p = caption.cstr() + top;
	int w = pos.w;
	go(pos_x(), pos_y());
	
	if (w > 2) {
		if (top) { print('<', c2); w--; p++; }
		if ((int)strlen(p) > w) w--;
		else c2 = 0;
	} else
		c2 = 0;
	
	while (w-->0)
		if (*p)
			print((unsigned char)*p++, col);
		else
			print(' ', col2);
	
	if (c2)	print('>', c2);
	
	if (is_active() && caption.cstr()[cp] == 0) {
		go(pos_x() + cp - top, pos_y());
		print('_', col2);
	}
	go(pos_x() + cp - top, pos_y());
	stick_cursor();
}

void InputLine::handle_event(Event &e)
{
	int c;
	int bl;
	bl = strlen(caption);

	Widget::handle_event(e);
	if (e.type != Event::keyboard)
		return;
	switch (c = e.data) {
	case key_left:	cp--;	break;
	case key_right:	cp++;	break;
	case key_home:	cp=0;	break;
	case key_end:	cp=caption.strlen(); break;
	case '\b':	if (!cp) break; cp--;
	case key_del:
		if (deadly) {
			caption = "";
			cp = top = 0;
		} else
			memmove(caption.cstr() + cp, caption.cstr() + cp + 1,
				caption.strlen() - cp);
		break;
	default:
		if ((c & 0xff) == c && c >= ' ') {
			if (deadly) {
				caption = "";
				cp = top = 0;
			}
			if (!fixed || (int)strlen(caption) < pos.w) {
				caption = caption + " ";
				memmove(caption.cstr() + cp + 1, 
					caption.cstr() + cp,
					caption.strlen() - cp - 1);
				caption.cstr()[cp++] = c;
			}
		} else
			return;
		break;	
	}
	
	deadly = false;
	e.kill();
	
	if (limit && bl != limit && (int)strlen(caption) == limit) {
		e.type = Event::keyboard;
		e.data = '\n';
		parent->handle_event(e);
		parent->draw();
	} else
		draw();
}

void InputLine::activate_hook()
{
	deadly = 1; 
}
